/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// playFileName - The file name to store the recorded voice into.    recordFileName - The file name to store the recorded voice into.    duration - The maximum length of the recording in milliseconds.    terminationDigit - A digit that will be used by the user to stop the recording.    playTone - If true, play the record tone before recording starts.    stopOnSilence - If &gt; 0, the recording is interrupted if silence reach the value of this parameter (in milliseconds).    waitForCompletion - If true, the http request will reply only when the recording will be completed, otherwise a webhook shall be used to be notified on completion.
    /// </summary>
    [DataContract]
        public partial class PlayRecordParams :  IEquatable<PlayRecordParams>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PlayRecordParams" /> class.
        /// </summary>
        /// <param name="playFileName">playFileName.</param>
        /// <param name="recordFileName">recordFileName.</param>
        /// <param name="duration">duration.</param>
        /// <param name="terminationDigit">terminationDigit.</param>
        /// <param name="playTone">playTone.</param>
        /// <param name="stopOnSilence">stopOnSilence.</param>
        /// <param name="waitForCompletion">waitForCompletion.</param>
        public PlayRecordParams(string playFileName = default(string), string recordFileName = default(string), int? duration = default(int?), string terminationDigit = default(string), bool? playTone = default(bool?), int? stopOnSilence = default(int?), string? userContext = default(string?), bool? waitForCompletion = default(bool?))
        {
            this.PlayFileName = playFileName;
            this.RecordFileName = recordFileName;
            this.Duration = duration;
            this.TerminationDigit = terminationDigit;
            this.PlayTone = playTone;
            this.StopOnSilence = stopOnSilence;
            this.UserContext = userContext;
            this.WaitForCompletion = waitForCompletion;
        }
        
        /// <summary>
        /// Gets or Sets PlayFileName
        /// </summary>
        [DataMember(Name="playFileName", EmitDefaultValue=false)]
        public string PlayFileName { get; set; }

        /// <summary>
        /// Gets or Sets RecordFileName
        /// </summary>
        [DataMember(Name="recordFileName", EmitDefaultValue=false)]
        public string RecordFileName { get; set; }

        /// <summary>
        /// Gets or Sets Duration
        /// </summary>
        [DataMember(Name="duration", EmitDefaultValue=false)]
        public int? Duration { get; set; }

        /// <summary>
        /// Gets or Sets TerminationDigit
        /// </summary>
        [DataMember(Name="terminationDigit", EmitDefaultValue=false)]
        public string TerminationDigit { get; set; }

        /// <summary>
        /// Gets or Sets PlayTone
        /// </summary>
        [DataMember(Name="playTone", EmitDefaultValue=false)]
        public bool? PlayTone { get; set; }

        /// <summary>
        /// Gets or Sets StopOnSilence
        /// </summary>
        [DataMember(Name="stopOnSilence", EmitDefaultValue=false)]
        public int? StopOnSilence { get; set; }

        /// <summary>
        /// Gets or Sets UserContext
        /// </summary>
        [DataMember(Name = "userContext", EmitDefaultValue = false)]
        public string UserContext { get; set; }

        /// <summary>
        /// Gets or Sets WaitForCompletion
        /// </summary>
        [DataMember(Name="waitForCompletion", EmitDefaultValue=false)]
        public bool? WaitForCompletion { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class PlayRecordParams {\n");
            sb.Append("  PlayFileName: ").Append(PlayFileName).Append("\n");
            sb.Append("  RecordFileName: ").Append(RecordFileName).Append("\n");
            sb.Append("  Duration: ").Append(Duration).Append("\n");
            sb.Append("  TerminationDigit: ").Append(TerminationDigit).Append("\n");
            sb.Append("  PlayTone: ").Append(PlayTone).Append("\n");
            sb.Append("  StopOnSilence: ").Append(StopOnSilence).Append("\n");
            sb.Append("  UserContext: ").Append(UserContext).Append("\n");
            sb.Append("  WaitForCompletion: ").Append(WaitForCompletion).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as PlayRecordParams);
        }

        /// <summary>
        /// Returns true if PlayRecordParams instances are equal
        /// </summary>
        /// <param name="input">Instance of PlayRecordParams to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(PlayRecordParams input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.PlayFileName == input.PlayFileName ||
                    (this.PlayFileName != null &&
                    this.PlayFileName.Equals(input.PlayFileName))
                ) && 
                (
                    this.RecordFileName == input.RecordFileName ||
                    (this.RecordFileName != null &&
                    this.RecordFileName.Equals(input.RecordFileName))
                ) && 
                (
                    this.Duration == input.Duration ||
                    (this.Duration != null &&
                    this.Duration.Equals(input.Duration))
                ) && 
                (
                    this.TerminationDigit == input.TerminationDigit ||
                    (this.TerminationDigit != null &&
                    this.TerminationDigit.Equals(input.TerminationDigit))
                ) && 
                (
                    this.PlayTone == input.PlayTone ||
                    (this.PlayTone != null &&
                    this.PlayTone.Equals(input.PlayTone))
                ) && 
                (
                    this.StopOnSilence == input.StopOnSilence ||
                    (this.StopOnSilence != null &&
                    this.StopOnSilence.Equals(input.StopOnSilence))
                ) && 
                (
                    this.WaitForCompletion == input.WaitForCompletion ||
                    (this.WaitForCompletion != null &&
                    this.WaitForCompletion.Equals(input.WaitForCompletion))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.PlayFileName != null)
                    hashCode = hashCode * 59 + this.PlayFileName.GetHashCode();
                if (this.RecordFileName != null)
                    hashCode = hashCode * 59 + this.RecordFileName.GetHashCode();
                if (this.Duration != null)
                    hashCode = hashCode * 59 + this.Duration.GetHashCode();
                if (this.TerminationDigit != null)
                    hashCode = hashCode * 59 + this.TerminationDigit.GetHashCode();
                if (this.PlayTone != null)
                    hashCode = hashCode * 59 + this.PlayTone.GetHashCode();
                if (this.StopOnSilence != null)
                    hashCode = hashCode * 59 + this.StopOnSilence.GetHashCode();
                if (this.WaitForCompletion != null)
                    hashCode = hashCode * 59 + this.WaitForCompletion.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
